<script setup lang="ts">
import { useAuthStore } from '@/stores/auth'
import { useBranchStore } from '@/stores/branch'
import { useExpenseStore } from '@/stores/expense'
import type { Branch } from '@/types/Branch'
import type { Expense } from '@/types/Expense'
import type { User } from '@/types/User'
import { computed, nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'

const expensesStore = useExpenseStore()
const branchStore = useBranchStore()

const monthlyExpenses = [
  {
    title: 'ID',
    key: 'ROWID',
    value: 'ROWID'
  },
  {
    title: 'Date',
    key: 'createDate',
    value: (expense: any) => new Date(expense.createDate).toLocaleDateString('en-GB')
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  // {
  //   title: 'Branch Name',
  //   key: 'branchName',
  //   value: 'branchName'
  //   // value: (expense: any | Branch) => expense.branchName.address
  // },
  {
    title: 'Bill Type',
    key: 'billType',
    value: 'billType'
  },
  {
    title: 'Total Amount',
    key: 'totalAmount',
    value: 'totalAmount'
  },

  { title: 'Actions', key: 'actions', sortable: false }
]
const monthlyExpensesDialog = [
  {
    title: 'ID',
    key: 'ROWID',
    value: 'ROWID'
  },
  {
    title: 'Date',
    key: 'createDate',
    value: (expense: any) => new Date(expense.createDate).toLocaleDateString('en-GB')
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  // {
  //   title: 'Branch Name',
  //   key: 'branchName',
  //   value: (expense: any | Branch) => expense.branchName.address
  // },
  {
    title: 'Bill Type',
    key: 'billType',
    value: 'billType'
  },
  {
    title: 'Total Amount',
    key: 'totalAmount',
    value: 'totalAmount'
  }
]
const page = ref(1)

const itemsPerPage = ref<any>(10)
const tab = ref(null)
const pageCount = computed(() => {
  return Math.ceil(expensesStore.expenses.length / itemsPerPage.value)
})
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const loading = ref(false)
const form = ref(false)
const dialogView = ref(false)
const dialogMonthly = ref(false)
const dialogDelete = ref(false)
let selectedExpense: Expense | null = null
const search = ref<string>('')
const dialogSumMonth = ref(false)
const dialogGraph = ref(false)
const userStore = useAuthStore()
const selectedBranchIndex = ref(null)
const dialogSelectBranch = ref(false)

function onSubmit() {}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    expensesStore.clearForm()
  })
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    expensesStore.clearForm()
  })
  dialogMonthly.value = false
  dialogView.value = false
}

function showSumMonth() {
  dialogSumMonth.value = true
}

function showGraphMonth() {
  dialogGraph.value = true
}

async function deleteItemConfirm() {
  // Delete item from list
  await expensesStore.deleteExpense()
  closeDelete()
}

async function deleteItem(item: Expense) {
  if (!item.id) return
  await expensesStore.getExpense(item.id)
  dialogDelete.value = true
}

async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  closeDialog()
  await expensesStore.saveExpense()
}

function showExpense(item: Expense) {
  selectedExpense = item
  dialogView.value = true
}

function showMonthExp() {
  const selectedMonth = new Date(expensesStore.editedExpense.createDate).toLocaleDateString(
    'en-GB',
    { month: '2-digit', year: 'numeric' }
  )
  const filteredExpenses = filterExpensesForMonth(expensesStore.expensesData, selectedMonth)
  const totalMonthlyExpenses = calculateMonthlyTotal(filteredExpenses)
  console.log('Total expenses for the selected month:', totalMonthlyExpenses)
  expensesStore.monthExpense(expensesStore.editedExpense)
  closeDialog()
}

function filterExpensesForMonth(expenses: any[], selectedMonth: string) {
  return expenses.filter((expense) => {
    const expenseMonth = new Date(expense.createDate).toLocaleDateString('en-GB', {
      month: '2-digit',
      year: 'numeric'
    })
    return expenseMonth === selectedMonth
  })
}

const formattedExpenses = computed(() =>
  expensesStore.expensesData.map((expense) => ({
    ...expense
  }))
)

const showTableBranch = (branch: any) => {
  if (branch !== null && branch.id !== undefined) {
    selectedBranchIndex.value = branch.id
  } else {
    selectedBranchIndex.value = null
  }
}

const filteredExpenses = computed(() => {
  const selectedBranchId = selectedBranchIndex.value
  if (selectedBranchId !== null) {
    return formattedExpenses.value.filter(
      (expense) => expense.branchName && expense.branchName.id === selectedBranchId
    )
  } else {
    return formattedExpenses.value
  }
})

function selectBranch(branch: any) {
  // Assuming you have a method to filter expenses by branch in your store
  expensesStore.filterExpensesByBranch(branch.id)
}

onMounted(async () => {
  await expensesStore.getExpenses()
  await branchStore.getBranchs()
  expensesStore.editedExpense.createDate = new Date()
  //   expensesStore.monthExpense(expensesStore.editedExpense)
})

function calculateMonthlyTotal(expenses: any[]) {
  return expenses.reduce((total, expense) => total + expense.totalAmount, 0)
}

const isAdmin = computed(() => {
  const currentUser: User | null = userStore.getCurrentUser()
  if (currentUser !== null && currentUser !== undefined) {
    return currentUser.roles.some((role) => role.name === 'Manager' || role.name === 'Owner')
  }
  return false
})


</script>
<template>
  <div>
    <v-card-title class="d-flex align-center pe-2">
      <h1 style="text-align: start">SUMMARY MONTHLY EXPENSE</h1>
    </v-card-title>

    <v-row
      ><v-col cols="12" sm="6"
        ><v-text-field
          class="ma-2"
          v-model="search"
          max-width="200px"
          prepend-inner-icon="mdi-magnify"
          density="compact"
          label="Search"
          single-line
          flat
          hide-details
          variant="solo-filled"
        ></v-text-field
      ></v-col>
      <v-col
        ><v-dialog v-model="dialogMonthly" max-width="300">
          <template v-slot:activator="{ props }">
            <v-btn class="ma-2" style="background-color: rgb(139, 82, 38)" v-bind="props">
              <v-icon icon=" mdi-calendar" size="25px" class="mr-2" color="#FFFFFF"></v-icon>
              <div style="text-align: center; color: aliceblue">Select month</div>
            </v-btn>
          </template>
          <v-card>
            <v-card-title class="font ma-4 pt-6" style="text-align: center"
              >Select month</v-card-title
            >
            <v-col cols="12" sm="12">
              <v-text-field
                v-model="expensesStore.editedExpense.createDate"
                :readonly="loading"
                class="mb-2"
                label="Select month"
                variant="outlined"
                type="month"
              ></v-text-field>
            </v-col>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn
                color="red"
                variant="flat"
                style="width: 100px"
                class="mb-3"
                @click="dialogMonthly = false"
                >Cancel</v-btn
              >
              <v-btn
                color="success"
                variant="flat"
                style="width: 100px"
                class="mb-3"
                @click="showMonthExp()"
                >OK</v-btn
              >
              <v-spacer></v-spacer>
            </v-card-actions>
          </v-card> </v-dialog
        ><v-menu id="menu-activator">
          <template v-slot:activator="{ props }">
            <v-btn class="ma-2" style="background-color: rgb(139, 82, 38)" v-bind="props">
              <v-icon icon=" mdi-chart-bar" size="25px" class="mr-2" color="#FFFFFF"></v-icon>
              <div style="text-align: center; color: aliceblue">report</div></v-btn
            ></template
          >
          <v-list>
            <v-list-item @click="showSumMonth()"
              ><v-list-item-title style="text-align: center">Report</v-list-item-title></v-list-item
            >
            <!-- <v-list-item @click="showGraphMonth()">
              <v-list-item-title style="text-align: center">Graph</v-list-item-title>
            </v-list-item> -->
          </v-list>
        </v-menu></v-col
      >
    </v-row>
    <!-- <v-menu id="menu-activator">
      <template v-slot:activator="{ props }">
        <v-btn class="ma-2" color="rgb(139, 82, 38)" v-bind="props"> Select Branch </v-btn>
      </template>
      <v-list>
        <v-list-item
          v-for="(branch, index) in branchStore.branchs"
          :key="index"
          @click="showTableBranch(branch)"
        >
          <v-list-item-title style="text-align: center">{{ branch.address }}</v-list-item-title>
        </v-list-item>
      </v-list>
    </v-menu> -->
  </div>
  <v-tabs v-model="tab" align-tabs="center" color="brown">
    <v-tab :to="{ name: 'expense' }">Expense</v-tab>
    <v-tab :to="{ name: 'monthly-expense' }" v-if="isAdmin">Monthly Expenses</v-tab>
    <v-tab :to="{ name: 'annual-expense' }" v-if="isAdmin">Annual Expenses</v-tab>
  </v-tabs>

  <v-data-table
    v-model:page="page"
    :headers="monthlyExpenses"
    :items="filteredExpenses"
    :items-per-page="itemsPerPage"
    ><template v-slot:bottom>
      <div class="text-center pt-2">
        <v-pagination v-model="page" :length="pageCount"></v-pagination>
      </div> </template
    ><template v-slot:[`item.actions`]="{ item }">
      <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
      <v-icon size="small" @click="showExpense(item)"> mdi-eye </v-icon>
    </template>
  </v-data-table>

  <!-- dialog Expense detail -->
  <v-dialog v-model="dialogView" persistent width="400">
    <v-card>
      <v-card-title class="font ma-4 pt-6" style="text-align: center"
        >Expense Details
      </v-card-title>
      <v-card-text>
        <div v-if="selectedExpense" style="text-align: start">
          <p>Date : {{ new Date(selectedExpense.createDate).toLocaleDateString('en-GB') }}</p>
          <p>Name : {{ selectedExpense.name }}</p>
          <p>Branch : {{ selectedExpense.branchName?.address }}</p>
          <p>Bill Type : {{ selectedExpense.billType }}</p>
          <p>Note : {{ selectedExpense.note }}</p>
          <p>Total Amount : {{ selectedExpense.totalAmount }}</p>
        </div>
      </v-card-text>
      <v-card-actions
        ><v-spacer></v-spacer>
        <v-btn color="red" variant="flat" class="mb-3" @click="dialogView = false">Close</v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>

  <v-dialog v-model="dialogSumMonth" persistent width="1000">
    <v-card>
      <v-card-title class="font ma-4 pt-8" style="text-align: center"
        >Summary Monthly Expense
      </v-card-title>
      <v-card-text style="font-size: larger"
        >ToTal : {{ calculateMonthlyTotal(expensesStore.expensesData) }} ฿</v-card-text
      >
      <v-data-table
        v-model:page="page"
        :headers="monthlyExpensesDialog"
        :items="expensesStore.expensesData"
        :items-per-page="itemsPerPage"
        ><template v-slot:bottom>
          <div class="text-center pt-2">
            <v-pagination v-model="page" :length="pageCount"></v-pagination>
          </div>
        </template>
      </v-data-table>

      <v-card-actions
        ><v-spacer></v-spacer>
        <v-btn color="red" variant="flat" class="mb-3" @click="dialogSumMonth = false">Close</v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>

  <v-dialog v-model="dialogGraph" persistent width="1000">
    <v-card>
      <v-card-title class="font ma-4 pt-8" style="text-align: center"
        >Monthly Expenses Total Graph
      </v-card-title>

      <v-card-actions
        ><v-spacer></v-spacer>
        <v-btn color="red" variant="flat" class="mb-3" @click="dialogGraph = false">Close</v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
  <!-- dialog ลบ -->
  <v-dialog v-model="dialogDelete" max-width="500px">
    <v-card>
      <v-card-title class="font ma-4 pt-6" style="text-align: center"
        >you want to delete this info? 🗑️</v-card-title
      >
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn
          color="red"
          variant="flat"
          style="width: 150px; height: 50px"
          class="mb-3"
          @click="closeDelete"
          >Cancel</v-btn
        >
        <v-btn
          color="success"
          variant="flat"
          style="width: 150px; height: 50px"
          class="mb-3"
          @click="deleteItemConfirm"
          >OK</v-btn
        >
        <v-spacer></v-spacer>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
<style>
div {
  font-family: 'Kanit';
}
</style>
